
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Numbering_sequencesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const numbering_sequences = await db.numbering_sequences.create(
            {
                id: data.id || undefined,
        
        document_type: data.document_type
        ||
        null
            ,
            
        prefix: data.prefix
        ||
        null
            ,
            
        next_number: data.next_number
        ||
        null
            ,
            
        padding: data.padding
        ||
        null
            ,
            
        format_hint: data.format_hint
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await numbering_sequences.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        

        

        

        return numbering_sequences;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const numbering_sequencesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                document_type: item.document_type
            ||
            null
            ,
            
                prefix: item.prefix
            ||
            null
            ,
            
                next_number: item.next_number
            ||
            null
            ,
            
                padding: item.padding
            ||
            null
            ,
            
                format_hint: item.format_hint
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const numbering_sequences = await db.numbering_sequences.bulkCreate(numbering_sequencesData, { transaction });

        // For each item created, replace relation files
        

        return numbering_sequences;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const numbering_sequences = await db.numbering_sequences.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.document_type !== undefined) updatePayload.document_type = data.document_type;
        
        
        if (data.prefix !== undefined) updatePayload.prefix = data.prefix;
        
        
        if (data.next_number !== undefined) updatePayload.next_number = data.next_number;
        
        
        if (data.padding !== undefined) updatePayload.padding = data.padding;
        
        
        if (data.format_hint !== undefined) updatePayload.format_hint = data.format_hint;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        updatePayload.updatedById = currentUser.id;

        await numbering_sequences.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await numbering_sequences.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        

        
        

        

        return numbering_sequences;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const numbering_sequences = await db.numbering_sequences.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of numbering_sequences) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of numbering_sequences) {
                await record.destroy({transaction});
            }
        });


        return numbering_sequences;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const numbering_sequences = await db.numbering_sequences.findByPk(id, options);

        await numbering_sequences.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await numbering_sequences.destroy({
            transaction
        });

        return numbering_sequences;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const numbering_sequences = await db.numbering_sequences.findOne(
            { where },
            { transaction },
        );

        if (!numbering_sequences) {
            return numbering_sequences;
        }

        const output = numbering_sequences.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.organization = await numbering_sequences.getOrganization({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.prefix) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'numbering_sequences',
                        'prefix',
                        filter.prefix,
                    ),
                };
            }
            
            if (filter.format_hint) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'numbering_sequences',
                        'format_hint',
                        filter.format_hint,
                    ),
                };
            }
            

            
            

            
            if (filter.next_numberRange) {
                const [start, end] = filter.next_numberRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    next_number: {
                    ...where.next_number,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    next_number: {
                    ...where.next_number,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.paddingRange) {
                const [start, end] = filter.paddingRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    padding: {
                    ...where.padding,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    padding: {
                    ...where.padding,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.document_type) {
                where = {
                    ...where,
                document_type: filter.document_type,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.numbering_sequences.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'numbering_sequences',
                        'prefix',
                        query,
                    ),
                ],
            };
        }

        const records = await db.numbering_sequences.findAll({
            attributes: [ 'id', 'prefix' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['prefix', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.prefix,
        }));
    }

    
};

